package kz.arta.ext.sap.entity;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
public class User {
    private String userid;
    private String firstname;
    private String lastname;
    private String patronymic;

    /**
     * Метод должен возвращать имя пользователя в формате Фамилия И.О.
     * Method return the username in the format Lastname F.P.
     *
     * @return имя пользователя
     */
    public String getPersonName() {
        StringBuilder name = new StringBuilder();
        if (lastname != null) {
            name.append(lastname);
        } else {
            return "";
        }
        if (firstname != null && firstname.length() > 0) {
            name.append(" ");
            name.append(firstname.substring(0, 1));
            name.append(".");
        } else {
            return lastname;
        }
        if (patronymic != null && patronymic.length() > 0) {
            name.append(patronymic.substring(0, 1));
            name.append(".");
        } else {
            return name.toString();
        }
        return name.toString();
    }

}
