package kz.arta.ext.sap.util;

import com.sun.org.apache.xerces.internal.impl.dv.util.Base64;

import org.apache.http.Consts;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.DefaultHttpClient;

import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import java.io.BufferedReader;
import java.io.InputStreamReader;

public class HTTPRequestUtils {

    @TransactionAttribute(TransactionAttributeType.REQUIRES_NEW)
    public static String sendGet(String url, String login, String password) throws Exception {

        CloseableHttpClient client = new DefaultHttpClient();
        InputStreamReader isr = null;
        BufferedReader rd = null;

        try {

            HttpGet request = new HttpGet(url);

            String usernameColonPassword = login + ":" + password;
            String basicAuthPayload = "Basic " + Base64.encode(usernameColonPassword.getBytes("UTF-8"));
            request.addHeader("Authorization", basicAuthPayload);

            HttpResponse response = client.execute(request);
            request.completed();

            isr = new InputStreamReader(response.getEntity().getContent());
            rd = new BufferedReader(isr);

            StringBuffer result = new StringBuffer();
            String line = "";
            while ((line = rd.readLine()) != null) {
                result.append(line);
            }

            return result.toString();

        } finally {

            isr.close();
            rd.close();
            client.close();

        }

    }

    @TransactionAttribute(TransactionAttributeType.REQUIRES_NEW)
    public static String sendPost(String url, String json, String login, String password) throws Exception {

        CloseableHttpClient client = new DefaultHttpClient();
        InputStreamReader isr = null;
        BufferedReader rd = null;

        try {

            client = new DefaultHttpClient();
            HttpPost request = new HttpPost(url);

            String usernameColonPassword = login + ":" + password;
            String basicAuthPayload = "Basic " + Base64.encode(usernameColonPassword.getBytes("UTF-8"));
            request.addHeader("Authorization", basicAuthPayload);

            request.setHeader("Content-type", "application/json; charset=utf-8");
            StringEntity entity = new StringEntity(json, Consts.UTF_8);
            request.setEntity(entity);

            HttpResponse response = client.execute(request);
            request.completed();

            isr = new InputStreamReader(response.getEntity().getContent());
            rd = new BufferedReader(isr);

            StringBuffer result = new StringBuffer();
            String line = "";
            while ((line = rd.readLine()) != null) {
                result.append(line);
            }

            return result.toString();

        } finally {

            isr.close();
            rd.close();
            client.close();

        }
    }

}
